Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1359)
+++ palm/trunk/SOURCE/Makefile	(revision 1360)
@@ -20,10 +20,13 @@
 # Current revisions:
 # ------------------
-# mod_particle_attributes added, lpm_sort_arrays removed, 
-# lpm_extend_particle_array removed
-#
+# 
+# 
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 1359 2014-04-11 17:15:14Z hoffmann
+# mod_particle_attributes added, lpm_sort_arrays removed, 
+# lpm_extend_particle_array removed
 #
 # 1336 2014-03-25 15:07:20Z raasch
Index: palm/trunk/SOURCE/Makefile_check
===================================================================
--- palm/trunk/SOURCE/Makefile_check	(revision 1359)
+++ palm/trunk/SOURCE/Makefile_check	(revision 1360)
@@ -20,9 +20,12 @@
 # Current revisions:
 # ------------------
-# mod_particle_attributes added
-#
+# 
+# 
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 1359 2014-04-11 17:15:14Z hoffmann
+# mod_particle_attributes added
 #
 # 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 1359)
+++ palm/trunk/SOURCE/check_open.f90	(revision 1360)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! -----------------
-! Format of particle exchange statistics extended to reasonable numbers of      
-! particles.
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! Format of particle exchange statistics extended to reasonable numbers of      
+! particles.
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute,
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1359)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1360)
@@ -20,8 +20,5 @@
 ! Current revisions:
 ! -----------------
-! Do not allow the execution of PALM with use_particle_tails, since particle
-! tails are currently not supported by our new particle structure.
-!
-! PA0084 not necessary for new particle structure
+! 
 ! 
 ! Former revisions:
@@ -29,4 +26,10 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! Do not allow the execution of PALM with use_particle_tails, since particle
+! tails are currently not supported by our new particle structure.
+!
+! PA0084 not necessary for new particle structure
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 1359)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1360)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1359)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1360)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 1359)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 1360)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/data_output_ptseries.f90
===================================================================
--- palm/trunk/SOURCE/data_output_ptseries.f90	(revision 1359)
+++ palm/trunk/SOURCE/data_output_ptseries.f90	(revision 1360)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1359)
+++ palm/trunk/SOURCE/header.f90	(revision 1360)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! dt_sort_particles removed
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! dt_sort_particles removed
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute 
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1359)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1360)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! ------------------
-! module lpm_init_mod added to use statements, because lpm_init has become a 
-! module
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! module lpm_init_mod added to use statements, because lpm_init has become a 
+! module
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute 
Index: palm/trunk/SOURCE/lpm.f90
===================================================================
--- palm/trunk/SOURCE/lpm.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- palm/trunk/SOURCE/lpm_advec.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_advec.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
 !
 ! 1322 2014-03-20 16:38:49Z raasch
Index: palm/trunk/SOURCE/lpm_boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90
===================================================================
--- palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_collision_kernels.f90
===================================================================
--- palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 1360)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated.
-! Kind definition added to all floating point numbers.
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated.
+! Kind definition added to all floating point numbers.
+! 
 ! 1346 2014-03-27 13:18:20Z heinze
 ! Bugfix: REAL constants provided with KIND-attribute especially in call of 
Index: palm/trunk/SOURCE/lpm_data_output_particles.f90
===================================================================
--- palm/trunk/SOURCE/lpm_data_output_particles.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_data_output_particles.f90	(revision 1360)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! ------------------
-! netCDF output currently not available
-! output of particle data in binary format adopted to new particle structure
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! netCDF output currently not available
+! output of particle data in binary format adopted to new particle structure
+! 
 ! 1327 2014-03-21 11:00:16Z raasch
 ! -netcdf output queries
Index: palm/trunk/SOURCE/lpm_droplet_collision.f90
===================================================================
--- palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
 !
 ! 1322 2014-03-20 16:38:49Z raasch
Index: palm/trunk/SOURCE/lpm_droplet_condensation.f90
===================================================================
--- palm/trunk/SOURCE/lpm_droplet_condensation.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_droplet_condensation.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
 !
 ! 1346 2014-03-27 13:18:20Z heinze
Index: palm/trunk/SOURCE/lpm_exchange_horiz.f90
===================================================================
--- palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1360)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
+! 
 ! 1327 2014-03-21 11:00:16Z raasch
 ! -netcdf output queries
Index: palm/trunk/SOURCE/lpm_extend_tail_array.f90
===================================================================
--- palm/trunk/SOURCE/lpm_extend_tail_array.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_extend_tail_array.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated.
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated.
+! Kind definition added to all floating point numbers.
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_extend_tails.f90
===================================================================
--- palm/trunk/SOURCE/lpm_extend_tails.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_extend_tails.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated.
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated.
+! Kind definition added to all floating point numbers.
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- palm/trunk/SOURCE/lpm_init.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_init.f90	(revision 1360)
@@ -20,12 +20,15 @@
 ! Current revisions:
 ! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
 ! New particle structure integrated. 
 ! Kind definition added to all floating point numbers.
 ! lpm_init changed form a subroutine to a module.
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1327 2014-03-21 11:00:16Z raasch
 ! -netcdf_output
Index: palm/trunk/SOURCE/lpm_init_sgs_tke.f90
===================================================================
--- palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated.
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated.
+! Kind definition added to all floating point numbers.
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_pack_arrays.f90
===================================================================
--- palm/trunk/SOURCE/lpm_pack_arrays.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_pack_arrays.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_read_restart_file.f90
===================================================================
--- palm/trunk/SOURCE/lpm_read_restart_file.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_read_restart_file.f90	(revision 1360)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_release_set.f90
===================================================================
--- palm/trunk/SOURCE/lpm_release_set.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_release_set.f90	(revision 1360)
@@ -20,7 +20,5 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-! lpm_init changed form a subroutine to a module.
+! 
 ! 
 ! Former revisions:
@@ -28,4 +26,9 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
+! lpm_init changed form a subroutine to a module.
+! 
 ! 1327 2014-03-21 11:00:16Z raasch
 ! -netcdf output queries
Index: palm/trunk/SOURCE/lpm_set_attributes.f90
===================================================================
--- palm/trunk/SOURCE/lpm_set_attributes.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_set_attributes.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
-! Kind definition added to all floating point numbers.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
+! Kind definition added to all floating point numbers.
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_write_exchange_statistics.f90
===================================================================
--- palm/trunk/SOURCE/lpm_write_exchange_statistics.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_write_exchange_statistics.f90	(revision 1360)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/lpm_write_restart_file.f90
===================================================================
--- palm/trunk/SOURCE/lpm_write_restart_file.f90	(revision 1359)
+++ palm/trunk/SOURCE/lpm_write_restart_file.f90	(revision 1360)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! New particle structure integrated. 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/mod_particle_attributes.f90
===================================================================
--- palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1359)
+++ palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
 ! new module containing all particle related variables
 ! -dt_sort_particles
-!
-! Former revisions:
-! -----------------
-! $Id: $
 !
 ! Description:
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1359)
+++ palm/trunk/SOURCE/modules.f90	(revision 1360)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! particle_attributes moved to mod_particle_attributes.f90
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! particle_attributes moved to mod_particle_attributes.f90
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/package_parin.f90
===================================================================
--- palm/trunk/SOURCE/package_parin.f90	(revision 1359)
+++ palm/trunk/SOURCE/package_parin.f90	(revision 1360)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! -----------------
-! +alloc_factor, + min_nr_particle
-! -dt_sort_particles, -maximum_number_of_particles
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! +alloc_factor, + min_nr_particle
+! -dt_sort_particles, -maximum_number_of_particles
+! 
 ! 1340 2014-03-25 19:45:13Z kanani
 ! REAL constants defined as wp-kinds
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1359)
+++ palm/trunk/SOURCE/parin.f90	(revision 1360)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! REAL constants provided with KIND-attribute 
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1359 2014-04-11 17:15:14Z hoffmann
+! REAL constants provided with KIND-attribute 
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute 
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1359)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1360)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
 !
 ! 1353 2014-04-08 15:21:23Z heinze
Index: palm/trunk/SOURCE/user_lpm_advec.f90
===================================================================
--- palm/trunk/SOURCE/user_lpm_advec.f90	(revision 1359)
+++ palm/trunk/SOURCE/user_lpm_advec.f90	(revision 1360)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/user_lpm_init.f90
===================================================================
--- palm/trunk/SOURCE/user_lpm_init.f90	(revision 1359)
+++ palm/trunk/SOURCE/user_lpm_init.f90	(revision 1360)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/user_lpm_set_attributes.f90
===================================================================
--- palm/trunk/SOURCE/user_lpm_set_attributes.f90	(revision 1359)
+++ palm/trunk/SOURCE/user_lpm_set_attributes.f90	(revision 1360)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! New particle structure integrated. 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! New particle structure integrated. 
 !
 ! 1320 2014-03-20 08:40:49Z raasch
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 1359)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 1360)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! Bugfix using cloud_droplets solved. qc, qr*, nr* are no longer written in case
-! of cloud_droplets = .TRUE.
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1359 2014-04-11 17:15:14Z hoffmann
+! Bugfix using cloud_droplets solved. qc, qr*, nr* are no longer written in case
+! of cloud_droplets = .TRUE.
 !
 ! 1320 2014-03-20 08:40:49Z raasch