Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1361)
+++ palm/trunk/SOURCE/Makefile	(revision 1362)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# cpulog added to microphysics
+# 
 # 
 # Former revisions:
@@ -26,4 +26,7 @@
 # $Id$
 #
+# 1361 2014-04-16 15:17:48Z hoffmann
+# cpulog added to microphysics
+# 
 # 1359 2014-04-11 17:15:14Z hoffmann
 # mod_particle_attributes added, lpm_sort_arrays removed, 
Index: palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_bc.f90	(revision 1361)
+++ palm/trunk/SOURCE/advec_s_bc.f90	(revision 1362)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! nr and qr added
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1361 2014-04-16 15:17:48Z hoffmann
+! nr and qr added
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 1361)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 1362)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! accelerator and vector version for qr and nr added
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1361 2014-04-16 15:17:48Z hoffmann
+! accelerator and vector version for qr and nr added
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute,
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1361)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1362)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! -----------------
-! Bottom and top boundary conditions of rain water content (qr) and 
-! rain drop concentration (nr) changed to Dirichlet
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1361 2014-04-16 15:17:48Z hoffmann
+! Bottom and top boundary conditions of rain water content (qr) and 
+! rain drop concentration (nr) changed to Dirichlet
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1361)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1362)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! PA0363 removed
-! PA0362 changed 
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1361 2014-04-16 15:17:48Z hoffmann
+! PA0363 removed
+! PA0362 changed 
 !
 ! 1359 2014-04-11 17:15:14Z hoffmann
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1361)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1362)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! ------------------
-! tend_* removed
-! Bugfix: w_subs is not allocated anymore if it is already allocated
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1361 2014-04-16 15:17:48Z hoffmann
+! tend_* removed
+! Bugfix: w_subs is not allocated anymore if it is already allocated
+! 
 ! 1359 2014-04-11 17:15:14Z hoffmann
 ! module lpm_init_mod added to use statements, because lpm_init has become a 
Index: palm/trunk/SOURCE/init_cloud_physics.f90
===================================================================
--- palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1361)
+++ palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1362)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! sed_qc_const is now calculated here (2-moment microphysics)
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1361 2014-04-16 15:17:48Z hoffmann
+! sed_qc_const is now calculated here (2-moment microphysics)
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/microphysics.f90
===================================================================
--- palm/trunk/SOURCE/microphysics.f90	(revision 1361)
+++ palm/trunk/SOURCE/microphysics.f90	(revision 1362)
@@ -20,12 +20,15 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1361 2014-04-16 15:17:48Z hoffmann
 ! Bugfix in sedimentation_rain: Index corrected.
 ! Vectorized version of adjust_cloud added.
 ! Little reformatting of the code.
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1361)
+++ palm/trunk/SOURCE/modules.f90	(revision 1362)
@@ -20,12 +20,15 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1361 2014-04-16 15:17:48Z hoffmann
 ! tend_* removed
 ! call_microphysics_at_all_substeps added
 ! default of drizzle set to true
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1359 2014-04-11 17:15:14Z hoffmann
 ! particle_attributes moved to mod_particle_attributes.f90
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1361)
+++ palm/trunk/SOURCE/parin.f90	(revision 1362)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! +call_microphysics_at_all_substeps
+! 
 ! 
 ! Former revisions:
@@ -26,4 +26,7 @@
 ! $Id$
 !
+! 1361 2014-04-16 15:17:48Z hoffmann
+! +call_microphysics_at_all_substeps
+! 
 ! 1359 2014-04-11 17:15:14Z hoffmann
 ! REAL constants provided with KIND-attribute 
Index: palm/trunk/SOURCE/prandtl_fluxes.f90
===================================================================
--- palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 1361)
+++ palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 1362)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! -----------------
-! Bugfix: calculation of turbulent fluxes of rain water content (qrsws) and rain 
-! drop concentration (nrsws) added
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1361 2014-04-16 15:17:48Z hoffmann
+! Bugfix: calculation of turbulent fluxes of rain water content (qrsws) and rain 
+! drop concentration (nrsws) added
+! 
 ! 1340 2014-03-25 19:45:13Z kanani
 ! REAL constants defined as wp-kind
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1361)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1362)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1361 2014-04-16 15:17:48Z hoffmann
 ! Two-moment microphysics moved to the start of prognostic equations. This makes
 ! the 3d arrays for tend_q, tend_qr, tend_pt and tend_pt redundant.
@@ -27,8 +34,4 @@
 ! Two-moment cloud physics added for vector and accelerator optimization.
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute