Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 1365)
+++ /palm/trunk/SOURCE/Makefile	(revision 1366)
@@ -20,6 +20,5 @@
 # Current revisions:
 # ------------------
-# Added new module calc_mean_profile, previously in module buoyancy,
-# removed buoyancy dependency from nudging
+# 
 # 
 # Former revisions:
@@ -27,4 +26,8 @@
 # $Id$
 #
+# 1365 2014-04-22 15:03:56Z boeske
+# Added new module calc_mean_profile, previously in module buoyancy,
+# removed buoyancy dependency from nudging
+# 
 # 1363 2014-04-17 12:28:49Z keck
 # bugfix: cpulog added to lpm_pack_arrays
Index: /palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- /palm/trunk/SOURCE/buoyancy.f90	(revision 1365)
+++ /palm/trunk/SOURCE/buoyancy.f90	(revision 1366)
@@ -20,12 +20,15 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
 ! Calculation of reference state in subroutine calc_mean_profile moved to
 ! subroutine time_integration,
 ! subroutine calc_mean_profile moved to new file calc_mean_profile.f90
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: /palm/trunk/SOURCE/calc_mean_profile.f90
===================================================================
--- /palm/trunk/SOURCE/calc_mean_profile.f90	(revision 1365)
+++ /palm/trunk/SOURCE/calc_mean_profile.f90	(revision 1366)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
+! Initial revision
 !
 ! Description:
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1365)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1366)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
 ! Usage of large scale forcing for pt and q enabled:
 ! output for profiles of large scale advection (td_lsa_lpt, td_lsa_q), 
@@ -26,8 +33,4 @@
 ! check if use_subsidence_tendencies is used correctly
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1361 2014-04-16 15:17:48Z hoffmann
 ! PA0363 removed
Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 1365)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 1366)
@@ -21,6 +21,5 @@
 ! Current revisions:
 ! -----------------
-! Output of large scale advection, large scale subsidence and nudging tendencies
-! +sums_ls_l, ngp_sums_ls, use_subsidence_tendencies
+! 
 ! 
 ! Former revisions:
@@ -28,4 +27,8 @@
 ! $Id$
 !
+! 1365 2014-04-22 15:03:56Z boeske
+! Output of large scale advection, large scale subsidence and nudging tendencies
+! +sums_ls_l, ngp_sums_ls, use_subsidence_tendencies
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute 
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 1365)
+++ /palm/trunk/SOURCE/header.f90	(revision 1366)
@@ -20,12 +20,15 @@
 ! Current revisions:
 ! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
 ! New section 'Large scale forcing and nudging':
 ! output of large scale forcing and nudging information,
 ! new section for initial profiles created
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1359 2014-04-11 17:15:14Z hoffmann
 ! dt_sort_particles removed
Index: /palm/trunk/SOURCE/ls_forcing.f90
===================================================================
--- /palm/trunk/SOURCE/ls_forcing.f90	(revision 1365)
+++ /palm/trunk/SOURCE/ls_forcing.f90	(revision 1366)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
 ! Usage of large scale forcing for pt and q enabled:
 ! Added new subroutine ls_advec for horizontal large scale advection and large 
@@ -26,8 +33,4 @@
 ! variable t renamed nt
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1365)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1366)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
 ! Usage of large scale forcing enabled:
 ! increase pr_palm from 90 to 100 to allow for more standard profiles
@@ -25,8 +32,4 @@
 ! use_subsidence_tendencies
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1361 2014-04-16 15:17:48Z hoffmann
 ! tend_* removed
Index: /palm/trunk/SOURCE/nudging.f90
===================================================================
--- /palm/trunk/SOURCE/nudging.f90	(revision 1365)
+++ /palm/trunk/SOURCE/nudging.f90	(revision 1366)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
 ! Variable t renamed nt, variable currtnudge renamed tmp_tnudge,
 ! summation of nudging tendencies for data output added
@@ -26,8 +33,4 @@
 ! scale at each time step
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1355 2014-04-10 10:21:29Z heinze
 ! Error message specified.
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 1365)
+++ /palm/trunk/SOURCE/parin.f90	(revision 1366)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! -----------------
-! Usage of large scale forcing enabled:
-! +use_subsidence_tendencies
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1365 2014-04-22 15:03:56Z boeske
+! Usage of large scale forcing enabled:
+! +use_subsidence_tendencies
+! 
 ! 1361 2014-04-16 15:17:48Z hoffmann
 ! +call_microphysics_at_all_substeps
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1365)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1366)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
 ! Calls of ls_advec for large scale advection added, 
 ! subroutine subsidence is only called if use_subsidence_tendencies = .F.,
@@ -25,8 +32,4 @@
 ! +ls_index
 ! 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1361 2014-04-16 15:17:48Z hoffmann
 ! Two-moment microphysics moved to the start of prognostic equations. This makes
Index: /palm/trunk/SOURCE/subsidence.f90
===================================================================
--- /palm/trunk/SOURCE/subsidence.f90	(revision 1365)
+++ /palm/trunk/SOURCE/subsidence.f90	(revision 1366)
@@ -20,6 +20,5 @@
 ! Current revisions:
 ! -----------------
-! Summation of subsidence tendencies for data output added 
-! +ls_index, sums_ls_l, tmp_tend
+! 
 ! 
 ! Former revisions:
@@ -27,4 +26,8 @@
 ! $Id$
 !
+! 1365 2014-04-22 15:03:56Z boeske
+! Summation of subsidence tendencies for data output added 
+! +ls_index, sums_ls_l, tmp_tend
+! 
 ! 1353 2014-04-08 15:21:23Z heinze
 ! REAL constants provided with KIND-attribute
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 1365)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 1366)
@@ -20,12 +20,15 @@
 ! Current revisions:
 ! ------------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1365 2014-04-22 15:03:56Z boeske
 ! Reset sums_ls_l to zero at each timestep
 ! +sums_ls_l
 ! Calculation of reference state (previously in subroutine calc_mean_profile)
 
-! Former revisions:
-! -----------------
-! $Id$
-!
 ! 1342 2014-03-26 17:04:47Z kanani
 ! REAL constants defined as wp-kind