Index: palm/trunk/SCRIPTS/.mrun.config.hlrnIII
===================================================================
--- palm/trunk/SCRIPTS/.mrun.config.hlrnIII	(revision 1358)
+++ palm/trunk/SCRIPTS/.mrun.config.hlrnIII	(revision 1371)
@@ -33,28 +33,54 @@
 #
 # HLRN-III Berlin
-%tmp_user_catalog    /gfs1/work/<replace by your HLRN-III username>         lccrayb parallel
-%tmp_data_catalog    /gfs1/work/<replace by your HLRN-III username>         lccrayb parallel
-%compiler_name       ftn                         lccrayb parallel
-%compiler_name_ser   ftn                         lccrayb parallel
+%tmp_user_catalog    /gfs1/work/<replace by your HLRN-III username>     lccrayb parallel
+%tmp_data_catalog    /gfs1/work/<replace by your HLRN-III username>     lccrayb parallel
+%compiler_name       ftn                                                lccrayb parallel
+%compiler_name_ser   ftn                                                lccrayb parallel
 %cpp_options         -e:Z:-DMPI_REAL=MPI_DOUBLE_PRECISION:-DMPI_2REAL=MPI_2DOUBLE_PRECISION:-D__netcdf:-D__netcdf4:-D__netcdf4_parallel:-D__fftw   lccrayb parallel
-%mopts               -j:4                        lccrayb parallel
-%fopts               -em:-O3:-hnoomp:-hfp3:-hdynamic          lccrayb parallel
-%lopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-dynamic lccrayb parallel
+%mopts               -j:4                                               lccrayb parallel
+%fopts               -em:-O3:-hnoomp:-hfp3:-hdynamic                    lccrayb parallel
+%lopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-dynamic           lccrayb parallel
 %remote_username     <replace by your HLRN-III username>                lccrayb parallel
 %memory              1500                                               lccrayb parallel
 %modules             fftw:cray-hdf5-parallel:cray-netcdf-hdf5parallel   lccrayb parallel
 #
+# HLRN-III Berlin debug/trace mode
+%tmp_user_catalog    /gfs1/work/<replace by your HLRN-III username>     lccrayb parallel trace
+%tmp_data_catalog    /gfs1/work/<replace by your HLRN-III username>     lccrayb parallel trace
+%compiler_name       ftn                                                lccrayb parallel trace
+%compiler_name_ser   ftn                                                lccrayb parallel trace
+%cpp_options         -e:Z:-DMPI_REAL=MPI_DOUBLE_PRECISION:-DMPI_2REAL=MPI_2DOUBLE_PRECISION:-D__netcdf:-D__netcdf4:-D__netcdf4_parallel:-D__fftw   lccrayb parallel trace
+%mopts               -j:4                                               lccrayb parallel trace
+%fopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp             lccrayb parallel trace
+%lopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp             lccrayb parallel trace
+%remote_username     <replace by your HLRN-III username>                lccrayb parallel trace
+%memory              1600                                               lccrayb parallel trace
+%modules             fftw:cray-hdf5-parallel:cray-netcdf-hdf5parallel   lccrayb parallel trace
+#
 # HLRN-III Hannover
-%tmp_user_catalog    /gfs1/work/<replace by your HLRN-III username>         lccrayh parallel
-%tmp_data_catalog    /gfs1/work/<replace by your HLRN-III username>         lccrayh parallel
-%compiler_name       ftn                         lccrayh parallel
-%compiler_name_ser   ftn                         lccrayh parallel
+%tmp_user_catalog    /gfs1/work/<replace by your HLRN-III username>     lccrayh parallel
+%tmp_data_catalog    /gfs1/work/<replace by your HLRN-III username>     lccrayh parallel
+%compiler_name       ftn                                                lccrayh parallel
+%compiler_name_ser   ftn                                                lccrayh parallel
 %cpp_options         -e:Z:-DMPI_REAL=MPI_DOUBLE_PRECISION:-DMPI_2REAL=MPI_2DOUBLE_PRECISION:-D__netcdf:-D__netcdf4:-D__netcdf4_parallel:-D__fftw   lccrayh parallel
-%mopts               -j:4                        lccrayh parallel
-%fopts               -em:-O3:-hnoomp:-hfp3:-hdynamic          lccrayh parallel
-%lopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-dynamic lccrayh parallel
+%mopts               -j:4                                               lccrayh parallel
+%fopts               -em:-O3:-hnoomp:-hfp3:-hdynamic                    lccrayh parallel
+%lopts               -em:-O3:-hnoomp:-hfp3:-hdynamic:-dynamic           lccrayh parallel
 %remote_username     <replace by your HLRN-III username>                lccrayh parallel
 %memory              1500                                               lccrayh parallel
 %modules             fftw:cray-hdf5-parallel:cray-netcdf-hdf5parallel   lccrayh parallel
+#
+# HLRN-III Hannover debug/trace mode
+%tmp_user_catalog    /gfs1/work/<replace by your HLRN-III username>     lccrayh parallel trace
+%tmp_data_catalog    /gfs1/work/<replace by your HLRN-III username>     lccrayh parallel trace
+%compiler_name       ftn                                                lccrayh parallel trace
+%compiler_name_ser   ftn                                                lccrayh parallel trace
+%cpp_options         -e:Z:-DMPI_REAL=MPI_DOUBLE_PRECISION:-DMPI_2REAL=MPI_2DOUBLE_PRECISION:-D__netcdf:-D__netcdf4:-D__netcdf4_parallel:-D__fftw   lccrayh parallel trace
+%mopts               -j:4                                               lccrayh parallel trace
+%fopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp             lccrayh parallel trace
+%lopts               -eD:-em:-g:-R:b:-K:trap=fp:-O0:-hnoomp             lccrayh parallel trace
+%remote_username     <replace by your HLRN-III username>                lccrayh parallel trace
+%memory              1600                                               lccrayh parallel trace
+%modules             fftw:cray-hdf5-parallel:cray-netcdf-hdf5parallel   lccrayh parallel trace
 #             
 %write_binary        true                             restart
@@ -64,5 +90,5 @@
 #----------------------------------------------------------------------------
 #IC:
-IC:[[ \$localhost = lccrayb ]]  &&  export ATP_ENABLED=0
+IC:[[ \$localhost = lccrayb ]]  &&  export ATP_ENABLED=1
 IC:[[ \$localhost = lccrayb ]]  &&  export MPICH_GNI_BTE_MULTI_CHANNEL=disabled
 IC:[[ \$localhost = lccrayb ]]  &&  export APRUN_XFER_LIMITS=1
@@ -74,4 +100,6 @@
 IC:[[ \$localhost = lccrayb ]]  &&  E8="=8"
 IC:[[ \$localhost = lccrayb ]]  &&  export MPICH_MPIIO_HINTS="*DATA_**:striping_factor"\$E8
+IC:[[ \$localhost = lccrayh ]]  &&  export ATP_ENABLED=1
+IC:[[ \$localhost = lccrayh ]]  &&  export MPICH_GNI_BTE_MULTI_CHANNEL=disabled
 IC:[[ \$localhost = lccrayh ]]  &&  export APRUN_XFER_LIMITS=1
 IC:[[ \$localhost = lccrayh ]]  &&  export APRUN_XFER_STACK_LIMIT=0